; Sparring 86
; by Li Tao
; ltao@delta.fullerton.edu
; http://delta.fullerton.edu/~ltao
; 7/6/01

; Status information
; (odds go to evens)
;  0 - walking / standing
;  1 - walking
;  2 - ouchie!!
;  3 - start block
;  4 - finish block
;  5 - start punch
;  6 - finish punch
;  7 - start kick
;  8 - finish kick
;  9 - win
; 10 - finish flying kick

#include "ti86asm.inc"

.org _asm_exec_ram

	nop
	jp ProgStart
	.dw 0
	.dw ShellTitle

ShellTitle:
	.db "Sparring 86 v1.0 by Li Tao",0
ChooseChar:
    .db "Choose your character",0
ChooseChar2:
    .db "F1                        F2                     F3",0
ChooseChar3:
    .db "Choose your opponent    ",0
ChooseDif:
	.db "     Easy-F1 Hard-F5          ",0

ProgStart:
 call _clrScrn
 ld bc,18
 ld (_penCol),bc
 ld bc,8
 ld (_penRow),bc
 ld hl,ShellTitle
 call _vputs
 ld bc,24
 ld (_penCol),bc
 ld (_penRow),bc
 ld hl,ChooseChar2
 call _vputs

; Draw character sprites
 xor a ; ld a,0
 ld (Rev),a
 ld (Clear),a

 ld bc,18*256+32
 ld hl,CharacterA
 call DrawSprite

 ld bc,48*256+32
 ld hl,CharacterB
 call DrawSprite

 ld bc,78*256+32
 ld hl,CharacterC
 call DrawSprite

; get your character
 ld bc,20
 ld (_penCol),bc
 ld bc,16
 ld (_penRow),bc
 ld hl,ChooseChar
 call _vputs
 call ChooseCharacterLoop
 cp kExit
 push af
 push af
 call z,_homeup
 pop af
 call z,_clrScrn
 pop af
 ret z
 ld (P1Health),a
 ld (P1Pict),hl
 push de
 pop hl
 ld (P1CData),hl

; get opponent's character
 ld bc,20
 ld (_penCol),bc
 ld bc,16
 ld (_penRow),bc
 ld hl,ChooseChar3
 call _vputs
 call ChooseCharacterLoop
 cp kExit
 push af
 push af
 call z,_homeup
 pop af
 call z,_clrScrn
 pop af
 ret z
 ld (P2Health),a
 ld (P2Pict),hl
 push de
 pop hl
 ld (P2CData),hl

; Get difficulty
 ld bc,20
 ld (_penCol),bc
 ld bc,16
 ld (_penRow),bc
 ld hl,ChooseDif
 call _vputs
GetDifLoop:
 call _getkey
 cp kExit
 push af
 push af
 call z,_homeup
 pop af
 call z,_clrScrn
 pop af
 ret z
 sub kF1
 cp 5
 jr nc,GetDifLoop
 ld hl,DifData
 ld e,a
 ld d,0
 add hl,de
 add hl,de
 add hl,de
 ld a,(P1Health)
 add a,(hl)
 ld (P1Health),a
 inc hl
 ld a,(P2Health)
 add a,(hl)
 ld (P2Health),a
 inc hl
 ld a,(hl)
 ld (P2Dif),a

 jr Begin

DifData:
; P1 Health bonus, P2 Health bonus, delay factor bonus
 .db 40, 236, 12
 .db 20, 0, 3
 .db 0, 0, 0
 .db 0, 30, 251
 .db 236, 40, 251

; Inputs a character, returns pointer to sprite, pushes pointer to char data
ChooseCharacterLoop:
 call _getkey
 cp kF1
 jr z,ChooseCharacterA
 cp kF2
 jr z,ChooseCharacterB
 cp kF3
 jr z,ChooseCharacterC
 cp kExit
 ret z
 jr ChooseCharacterLoop
ChooseCharacterA:
 ld de,ACharData
 ld hl,CharacterA
 ld a,70
 ret
ChooseCharacterB:
 ld de,BCharData
 ld hl,CharacterB
 ld a,60
 ret
ChooseCharacterC:
 ld de,CCharData
 ld hl,CharacterC
 ld a,60
 ret

; called just before player 1 dies, flashes screen & changes status
MakeP1Dead:
 ld a,0
 ld (P1Health),a
 call DispHealth

 ld a,100
 ld (FlashLength),a
 call Flash
 ld a,9
 ld (P2Status),a
 ld b,250
MakeP1DeadL:
 halt
 djnz MakeP1DeadL
 jr MainLoop

MakeP2Dead:
 ld a,0
 ld (P2Health),a
 call DispHealth

 ld a,100
 ld (FlashLength),a
 call Flash
 ld a,9
 ld (P1Status),a
 ld b,250
MakeP2DeadL:
 halt
 djnz MakeP1DeadL
 jr MainLoop

; Initialization
Begin:
 call _clrScrn
; set fighter positions
 ld a,10
 ld (P1X),a
 ld (XP1X),a
 ld a,20
 ld (P1Y),a
 ld (XP1Y),a
 ld a,80
 ld (P2X),a
 ld (XP2X),a
 ld a,20
 ld (P2Y),a
 ld (XP2Y),a

; Set fighter stats
 xor a ; ld a,0
 ld (P1Status),a
 ld (P1Timer),a
 ld (P1XTimer),a
 ld (P1Damage),a
 ld (P1JumpCnt),a
 ld (P1JumpDelta),a
 ld (P1DelayFactor),a
 ld (P1ZTimer),a
 ld (P2Status),a
 ld (P2Timer),a
 ld (P2XTimer),a
 ld (P2Damage),a
 ld (P2DelayFactor),a
 ld (WinState),a
; ld (MainTimer),a  ; to keep game "random"
 ld a,7
 ld (FlashLength),a ; set normal flash length
 res 2,(iy+13) ; no scrolling
 call $4AB1 ; run indicator off
 ld bc,240
 call DispMessage ; taunting message
MainLoop:
; increase timer
 ld a,(MainTimer)
 inc a
 ld (MainTimer),a
 
 ; possible clear message buffer
 ld hl,MessageTimer
 cp (hl)
 call z,ClearMessage

; call _clrLCD 
; Player 1
 ; Clear original
 ld a,(XP1X)
 ld b,a
 ld a,(XP1Y)
 ld c,a
 ld hl,(XP1Status)
 ld a,(XP1Rev)
 ld (Rev),a
 ld a,1
 ld (Clear),a
 call DrawSprite

 ld a,(P1X)
 ld b,a
 ld (XP1X),a ; 
 ld a,(P1Y)
 ld c,a
 ld (XP1Y),a ;
 push bc
 ld de,(P1Pict)
 ld h,96
 ld a,(P1Status)
 ld l,a
 push de
 call $4547   ; HL = H * L
 pop de
 add hl,de
 ld (XP1Status),hl ;
 ld a,(P1Rev)
 ld (Rev),a
 ld (XP1Rev),a ;
 xor a ; ld a,0
 ld (Clear),a
 pop bc
 call DrawSprite 

; Player 2
 ; Clear original
 ld a,(XP2X)
 ld b,a
 ld a,(XP2Y)
 ld c,a
 ld hl,(XP2Status)
 ld a,(XP2Rev)
 ld (Rev),a
 ld a,1
 ld (Clear),a
 call DrawSprite

 ld a,(P2X)
 ld b,a
 ld (XP2X),a ; 
 ld a,(P2Y)
 ld c,a
 ld (XP2Y),a ; 
 push bc
 ld de,(P2Pict)
 ld h,96
 ld a,(P2Status)
 ld l,a
 push de
 call $4547   ; HL = H * L
 pop de
 add hl,de
 ld (XP2Status),hl ;
 ld a,(P2X)
 ld b,a
 ld a,(P1X)
 cp b
 ld b,0
 ld a,b ; not xor a because the carry flag would be reset
 adc a,b 
 ld (Rev),a
 ld (XP2Rev),a ;
 xor a ; ld a,0
 ld (Clear),a
 pop bc
 call DrawSprite

 call DispHealth

 ; Check for wins
 ld a,(P1Status)
 cp 9
 jp z,P2Dead
 ld a,(P2Status)
 cp 9
 jp z,P1Dead

 ; Check for deaths
 ld a,(P1Health) ; Player never has > 100 health
 cp 150
 jp nc,MakeP1Dead
 cp 0
 jp z,MakeP1Dead
 ld a,(P2Health) ; Enemy never has > 100 health
 cp 150
 jp nc,MakeP2Dead
 cp 0
 jp z,MakeP2Dead

; Read keys from port
 ld a,%00111111 
 out (1),a
 in a,(1)
 bit 5,a
 jp z,P1TermAttack
 bit 6,a
 jp nz,CheckP1Attack
 ld a,9
 ld (P2Status),a

CheckP1Attack:
; No attacking twice (esp. jump kicks)
 ld b,a
 ld a,(P1Status)
 cp 2
 jr nc,NoAttack

; No attacking with delay factor
 ld a,(P1DelayFactor)
 cp 0
 jr nz,DecDelayFactor

 ld a,b
 bit 4,a
 call z,P1StartPunch
 bit 3,a
 call z,P1StartKick
 bit 2,a
 call z,P1StartBlock
 jr NoAttack
DecDelayFactor: ; called if player has a delay factor (attacking or blocking)
 dec a
 ld (P1DelayFactor),a
NoAttack:

; Make sure you don't move/change direction when you are jumping
 ld a,(P1Y)
 cp 20
 jp nz,Back

; Check Direction
 ld a,(P1X)
 ld b,a
 ld a,(P2X)
 cp b
 ld b,0
 ld a,b ; not xor a because it clears carry
 adc a,b 
 ld (P1Rev),a

 ld a,%01111110
 out (1),a
 in a,(1)
 bit 3,a
 jp z,P1StartJump
 bit 2,a
 jp z,P1MoveRight
 bit 1,a
 jp z,P1MoveLeft

Back:
; Check jump stuff
 ld a,(P1Y)
 cp 20
 call nz,P1DoJump

; Enemy's turn
 ld a,(P2Status)
 cp 2
 jr nc,EAttackOrBlock
 ld a,(MainTimer)
 and 1
 cp 0
 jr z,ENothing
; Move toward player unless too close
 call GetDist
 cp 10
 jr c,MoveAwayPlayer
; If kind of close and player is attacking, move back
 cp 20
 jr nc,MoveToPlayer ; move toward player if far away
 ld a,(P1Status)
 cp 5
 jr nc,MoveAwayPlayer ; move away if player attacks and is close
MoveToPlayer:
 ld a,(P1X)
 ld b,a
 ld a,(P2X)
 jr MoveToBack
MoveAwayPlayer:
 ld a,(P2X)
 ld b,a
 ld a,(P1X)
MoveToBack:
; Moves toward player depending on location
 cp b
 jp c,P2MoveRight
 jp P2MoveLeft
EAttackOrBlock:
 ld a,(P2DelayFactor) ; Make sure no attacking until delay factor is ok
 cp 0
 jr z,EAttackOrBlock2 ; ok to attack/block
 dec a
 ld (P2DelayFactor),a ; decrease enemy's delay factor
 jr ENothing
EAttackOrBlock2:
 ; if it's close enough, it attacks or blocks, depending on if player is attacking
 call GetDist
 cp 15
 jr nc,ENothing
 ; block?
 ld a,(P1Status)
 cp 5
 jr c,EAttack
 call P2StartBlock
 jr ENothing
EAttack:
; Set delay factor
 ld hl,(P2CData)
 ld de,12 ; offset for delay factor
 add hl,de
 ld a,(hl)
 ld hl,P2Dif
 add a,(hl)

 ld (P2DelayFactor),a

 ld a,(P2Status)
 cp 5
 jr nc,ENothing ; skip if already attacking
; randomly punch or kick
 call Random
 and 1
 cp 1
 call z,P2StartPunch
 call nz,P2StartKick
ENothing:

; Check attacks

 ld a,(P1Status)
 cp 5        ; statuses 5+ are damage-doing
 jr c,Back2 ; No attacks
 and 1
 cp 1
 jr z,Back2  ; pre-attacks
 call CheckHit
 jr nc,Back2 ; missed, too far away
 ld a,(P2Status)
 cp 4
 jp z,Back3 ; blocked
; *hit*
 ld a,(P1Damage)
 cp 1
 call nc,Flash ; flash if damage
 push af
 ld bc,120
 call nc,DispMessage ; display 'ouch' message if damage
 pop af
 ld b,a
; Add 1 or 0 randomly, even if no damage
 call Random
 and 1
 add a,b
 ld b,a
 add a,5
 ld (P2Timer),a ; set enemy's ouch timer
 ld a,(P2Health)
 sub b
 ld (P2Health),a ; decrease health
 ld a,2
 ld (P2Status),a ; set enemy status to ouch
 xor a ; ld a,0
 ld (P1Damage),a ; no more damage for this attack
 ; enemy doesn't jump
Back2:
 
; Decrease counters
 ld a,(P1Status)
 cp 2
 jr c,SkipP1
 call DoPlayer1
SkipP1:
 ; same for p2
; Check attacks

 ld a,(P2Status)
 cp 5        ; statuses 5+ are damage-doing
 jr c,Back3 ; No attacks
 and 1
 cp 1
 jr z,Back3  ; pre-attacks
 call CheckHit
 jr nc,Back3 ; missed, too far away
 ld a,(P1Status)
 cp 4
 jr z,Back3 ; blocked
; *hit*
 ld a,(P2Damage)
 cp 1
 call nc,Flash ; flash if damage
 push af
 ld bc,0
 call nc,DispMessage ; display 'take that' message
 pop af
 ld b,a
; Add 1 or 0 randomly
 call Random
 and 1
 add a,b
 ld b,a

 add a,5
 ld (P1Timer),a ; set 'ouch' timer
 ld a,(P1Health)
 sub b
 ld (P1Health),a ; decrease player health
 ld a,2
 ld (P1Status),a ; set player status to ouch
 xor a ; ld a,0
 ld (P2Damage),a ; no more damage for this attack
 ld (P1JumpCnt),a ; If you get hit, you fall
 ld a,1
 ld (P1JumpDelta),a ; and you fall straight down
Back3:

; Decrease counters
 ld a,(P2Status)
 cp 2
 jr c,SkipP2
 call DoPlayer2

SkipP2:
 jp MainLoop




; function that returns the distance between P1X and P2X
; returns distance in A
GetDist:
 ld a,(P2X)
 ld b,a
 ld a,(P1X)
 cp b
 jr nc,NoSwitch ; P1X>P2X
; swap a,b (P1X<P2X)
 ld c,a
 ld a,b
 ld b,c
NoSwitch:
 sub b
 ret

; function that checks if someone would hit if they attacked
CheckHit:
 call GetDist
 cp 14
 ret

; Jumping routine (called every turn if jumping)
P1DoJump:
; check whether to fall
 ld a,(P1JumpCnt)
 cp 0
 jr z,P1DoFall

; Decrease jump counter
 dec a
 ld (P1JumpCnt),a

; Go up
 ld a,(P1Y)
 dec a
 ld (P1Y),a

P1DoJumpBack:
; move in direction
 ld a,(P1JumpDelta)
 ld b,a
 ld a,(P1X)
 dec a
 add a,b

; Check bounds
 cp 100
 ret z
 cp 0
 ret z
 ld (P1X),a
 ret

P1DoFall:
 ld a,(P1Y)
 inc a ; go down
 ld (P1Y),a
 jr P1DoJumpBack

; move player 1 right one pixel if it can
P1MoveRight:
 ld a,(P1X)
 inc a
 cp 100
 jp z,Back
 ld (P1X),a
P1TermAttack: ; do this if player pushes 2nd
; ld a,(P1X) ; for attack termination
 and 1
 ld (P1Status),a
 xor a ; ld a,0 ; No attacking, then moving!
 ld (P1Damage),a
 jp Back

; move player 1 left one pixel
P1MoveLeft:
 ld a,(P1X)
 dec a
 jp z,Back
 ld (P1X),a
 and 1
 ld (P1Status),a
 xor a ; ld a,0
 ld (P1Damage),a
 jp Back

; initialize jump stuff
P1StartJump:
 bit 1,a
 jr z,P1StartJumpLeft
 bit 2,a
 jr z,P1StartJumpRight
; jump straight up
 ld a,1
P1StartJumpBack:
 ld (P1JumpDelta),a ; set direction (1 more than the real delta)
 ld a,16
 ld (P1JumpCnt),a ; set counter
 ld a,19
 ld (P1Y),a ; set new Y position (to trigger the jumping routine)
 jp Back
P1StartJumpLeft:
 xor a ; ld a,0
 jr P1StartJumpBack
P1StartJumpRight:
 ld a,2
 jr P1StartJumpBack

; try to move player 2 right one pixel
P2MoveRight:
 ld a,(P2X)
 inc a
 cp 100
 jp z,EAttackOrBlock
 ld (P2X),a
 and 1
 ld (P2Status),a
; xor a ; ld a,0 ; No attacking, then moving!
; ld (P2Damage),a
 jp EAttackOrBlock

; try to move player 2 left one pixel
P2MoveLeft:
 ld a,(P2X)
 dec a
 jp z,EAttackOrBlock
 ld (P2X),a
 and 1
 ld (P2Status),a
; xor a ; ld a,0
; ld (P2Damage),a
 jp EAttackOrBlock

P1StartPunch:
 push af
 push hl
 ld a,5 ; punching status
 ld (P1Status),a

; set timers and damage depending on character choice
 ld hl,(P1CData)
 ld de,1 ; offset for timer
 add hl,de
 ld a,(hl)
 ld (P1Timer),a

 ld hl,(P1CData)
 ld de,2 ; offset for Xtimer
 add hl,de
 ld a,(hl)
 ld (P1XTimer),a

 ld hl,(P1CData)
 ld a,(hl) ; no offset for damage
 ld (P1Damage),a

 ld hl,(P1CData)
 ld de,3 ; offset for ZTimer
 add hl,de
 ld a,(hl)
 ld (P1ZTimer),a
 pop hl
 pop af
 ret

P1StartKick:
 push af
 push hl
; Special kick if jumping
 ld a,(P1Y)
 cp 20
 jr nz,P1JumpKick

 ld a,7
 ld (P1Status),a

; set timers and damage depending on character choice
 ld hl,(P1CData)
 ld de,5 ; offset for timer
 add hl,de
 ld a,(hl)
 ld (P1Timer),a

 ld hl,(P1CData)
 ld de,6 ; offset for Xtimer
 add hl,de
 ld a,(hl)
 ld (P1XTimer),a

 ld hl,(P1CData)
 ld de,4
 add hl,de
 ld a,(hl) ; offset for damage
 ld (P1Damage),a

 ld hl,(P1CData)
 ld de,7 ; offset for ZTimer
 add hl,de
 ld a,(hl)
 ld (P1Timer),a
 pop hl
 pop af
 ret
P1JumpKick:
 ld a,10
 ld (P1Status),a
 ld (P1Timer),a
; no XTimer because it's instantaneous
 ld hl,(P1CData)
 ld de,10
 add hl,de
 ld a,(hl) ; offset for damage
 ld (P1Damage),a

 ld hl,(P1CData)
 ld de,11
 add hl,de
 ld a,(hl) ; offset for ztimer
 ld (P1ZTimer),a
 pop hl
 pop af
 ret

P1StartBlock:
 push af
 push hl
 ld a,3
 ld (P1Status),a

; set timers and damage depending on character choice
 ld hl,(P1CData)
 ld de,8
 add hl,de
 ld a,(hl) ; offset for damage
 ld (P1Timer),a

 ld hl,(P1CData)
 ld de,9
 add hl,de
 ld a,(hl) ; offset for damage
 ld (P1XTimer),a

 xor a ; ld a,0
 ld (P1Damage),a
 xor a ; ld a,0
 ld (P1ZTimer),a
 pop hl
 pop af
 ret

P2StartPunch:
 push af
 push hl
 ld a,5
 ld (P2Status),a

; set timers and damage depending on character choice
 ld hl,(P2CData)
 ld de,1 ; offset for timer
 add hl,de
 ld a,(hl)
 ld (P2Timer),a

 ld hl,(P2CData)
 ld de,2 ; offset for Xtimer
 add hl,de
 ld a,(hl)
 ld (P2XTimer),a

 ld hl,(P2CData)
 ld a,(hl) ; no offset for damage
 ld (P2Damage),a

 pop hl
 pop af
 ret

P2StartKick:
 push af
 push hl
 ld a,7
 ld (P2Status),a

; set timers and damage depending on character choice
 ld hl,(P2CData)
 ld de,5 ; offset for timer
 add hl,de
 ld a,(hl)
 ld (P2Timer),a

 ld hl,(P2CData)
 ld de,6 ; offset for Xtimer
 add hl,de
 ld a,(hl)
 ld (P2XTimer),a

 ld hl,(P2CData)
 ld de,4
 add hl,de
 ld a,(hl) ; offset for damage
 ld (P2Damage),a

 pop hl
 pop af
 ret

P2StartBlock:
 push af
 push hl
 ld a,3
 ld (P2Status),a

; set timers and damage depending on character choice
 ld hl,(P2CData)
 ld de,8
 add hl,de
 ld a,(hl) ; offset for damage
 ld (P2Timer),a

 ld hl,(P2CData)
 ld de,9
 add hl,de
 ld a,(hl) ; offset for damage
 ld (P2XTimer),a

 xor a ; ld a,0
 ld (P2Damage),a
 pop hl
 pop af
 ret

DoPlayer1:
; decrement counter
 ld a,(P1Timer)
 dec a
 ld (P1Timer),a
 ret nz
; reached 0
 ld a,(P1Status)
 bit 0,a
 jr z,P1ResetStatus
; increase status
 inc a
 ld (P1Status),a
 ld a,(P1XTimer)
 ld (P1Timer),a
 ret
P1ResetStatus:
 xor a ; ld a,0 ; No damage
 ld (P1Damage),a
 xor a ; ld a,0
 ld (P1Status),a
; set delay factor so you wait before attacking
 ld a,(P1ZTimer)
 ld (P1DelayFactor),a
 ret

DoPlayer2:
; decrement counter
 ld a,(P2Timer)
 dec a
 ld (P2Timer),a
 ret nz
; reached 0
 ld a,(P2Status)
 bit 0,a
 jr z,P2ResetStatus
; increase status
 inc a
 ld (P2Status),a
 ld a,(P2XTimer)
 ld (P2Timer),a
 ret
P2ResetStatus:
 xor a ; ld a,0 ; No damage
 ld (P2Damage),a
 ld (P2Status),a
 ret


; B = X
; C = Y
; HL = sprite
; Draws a 24xsomething bitmap
DrawSprite:
 ld a,(Rev)
 cp 1
 jr z,DrawSpriteRev 
 push bc
 push hl
 call PutSprite
 pop hl
 pop bc
 ld a,b
 add a,8
 ld b,a
 inc hl
 push bc
 push hl
 call PutSprite
 pop hl
 pop bc
 ld a,b
 add a,8
 ld b,a
 inc hl
 push bc
 push hl
 call PutSprite
 pop hl
 pop bc
 ret

; draw it reversed
DrawSpriteRev:
 inc hl
 inc hl
 push bc
 push hl
 call PutSprite
 pop hl
 pop bc
 ld a,b
 add a,8
 ld b,a
 dec hl
 push bc
 push hl
 call PutSprite
 pop hl
 pop bc
 ld a,b
 add a,8
 ld b,a
 dec hl
 push bc
 push hl
 call PutSprite
 pop hl
 pop bc
 ret

; Modified version of routine from ACZ
PutSprite:

 push bc                        ; Save BC (X, Y) 
 push de                        ; Save DE
 push hl                        ; Save HL (Start of Sprite Data)
 push hl                        ; Save HL (Start of Sprite Data)

 push bc
 ld d, c
 ld e, b
 call FindPixel                 ; Finds pixel at E, D
 pop bc
                                ; PutSprite needs pixel at B, C
  
                                ; A = Bitmask with one bit set; this will be the bit (pixel) "counter"

 ex de,hl                       ; DE = Address in Display of Sprite
 pop hl                         ; HL = Start of Sprite Data
; ld b,(hl)                      ; B = X width of Sprite 
; inc hl                         ; Next byte
; ld c,(hl)                      ; C = Y width of Sprite
; inc hl                         ; Next byte (now pointing at actual sprite data)

 ld b,8                          ; always 8x8
 ld c,32

 push hl                        ; Save the twice incremented HL into stack
 pop ix                         ; IX = The recently twice incremented HL

 ex de,hl                       ; HL = Address in Display of Sprite

PS_NewRow:
 push bc                        ; Save X width of Sprite and Y width of Sprite
 ld d,(ix)                      ; D = (IX), so D = First byte from Sprite
 inc ix                         ; IX points to next row
 push af                        ; Save Bitmask 
 push hl                        ; Save HL, Address in Display of Sprite
PS_NewCol:                      ; Now the fun begins, remember A is the bitmask, D = the Left Column Byte from Sprite
 ld c,a
 ld a,(Rev)
 cp 1
 jr z,Reverse
 rl d
 jr OK
Reverse:
 rr d
OK:                                ; Rotate D left through carry, Leftmost pixel of Sprite Byte is carry
 ld a,c
 ld e,a                         ; E = bitmask
 jr nc,PS_NextPixel               ; Check pixel from sprite to see if it is set
 push af 
 ld a,(Clear)
 cp 1
 jr z,PS_Clear
 pop af
 or (hl)
PS_Back:
 ld (hl),a
 jr PS_NextPixel
PS_Clear:
 pop af
 cpl
 and (hl)
 jr PS_Back
PS_NextPixel:
 ld a,e                         ; A = Bitmask
 rrca                           ; A is rotated right *through* carry
 jr nc,PS_SameByte              ; If the carry was set, that means that one bit set in A (bit counter) 
                                ;  rotated all the way to the end right into carry and recycles back into Bit 7
                                ;  so it can be used for the next byte

 inc hl                         ; Go to the next byte in the display
PS_SameByte:
 djnz PS_NewCol                 ; B = X (width of sprite), so it loops to PS_NewCol X times. This means that is X = 6, 
                                ; it will Shift Right the bitmask (move the bit counter to the right) 6 times, comparing 
                                ; each bit of the bitmask and the sprite and setting or clearing the pixel in that
                                ; particular bit. It then moves on the the next pixel.

                                ; Move on to the next row
 pop hl                         ; Recover HL, the Address in Display of the Sprite
 pop af                         ; Recover AF, A = Bitmask
 ld de,16                       ; DE = 16
 add hl,de                      ; HL = HL + 16, this moves down ONE row in the Display Area (128 width / (8 bits/pixel) = 16 bytes)
 pop bc                         ; Recover X_width and Y_height of Sprite
 dec c                          ; C = Y_height of Sprite, subract one, which means one row of the Sprite has been drawn

 inc ix                         ; ** special part for 24x24 bitmaps!
 inc ix

 jr nz,PS_NewRow                ; If there are more rows to be drawn, go back to PS_NewRow

; No more rows. Since there were "effectively" 3 pushes before PS_NewRow, there must be three pops that way the
; ret statement will retrieve the correct address when it returns to the calling program.

 pop hl                                         
 pop de
 pop bc
 ret

Rev:
 .db 0
Clear:
 .db 0

; =============================================================
; Dan Eble & James Yopp FindPixel routine
; Input:  D = y, E = x
; Output: HL= addr in vid mem, A = bitmask, C is modified
; =============================================================
FindPixel:
        ld hl,FP_Bits
        ld a,e
        and $07         ; a = bit offset
        add a,l
        ld l,a
        adc a,h
        sub l
        ld h,a
        ld c,(hl)       ; c = bitmask for (hl)
;48 t-states up to this point
        ld hl,FP_RLD
        ld (hl),d
        ld a,e          ; a = x/8 (byte offset within row)
        rrca
        rrca   
        rrca
        rld
        or $FC  ;
        ld l,(hl)
        ld h,a          ; hl -> byte in vid mem
;        push de
;        ld de,DB
;        add hl,de
;        pop de
        ld a,c          ; now a = bitmask for (hl)
;121 t-states up to this point
        ret

; Random number routine from FallDown Forever
Random:
	;This routine uses rom data to simulate random numbers...
	;It does a rather poor job of it, but it's good enough for
	;this game
	push hl
	ld a,r						;a=random-ish number <128
	srl a						;a<64
	ld h,a						;use that as the upper byte of an address (always rom page 0)
Lrand:
	ld l,0						;use some value as the lower byte... (self-modifying)
	add a,(hl)					;get a number from there
	ld (Lrand+1),a				;and use that as the next lower byte	
	pop hl
	ret

P1Dead:
 ld bc,360
 call DispMessage

 ld bc,50
 ld (_penCol),bc
 ld bc,15
 ld (_penRow),bc
 ld hl,LoseMesg
 call _vputs
 ld a,(P1Health)
 cp 0
 jr nz,P1JustQuit
 ld b,250
P1DeadL:
 halt
 djnz P1DeadL
P1JustQuit:
 call _getkey
 jr Quit
P2Dead:
 ld bc,480
 call DispMessage

 ld bc,50
 ld (_penCol),bc
 ld bc,15
 ld (_penRow),bc
 ld hl,WinMesg
 call _vputs
 ld b,250
P2DeadL:
 halt
 djnz P2DeadL
 call _getkey
 jr Quit
WinMesg:
 .db "You win!",0
LoseMesg:
 .db "You lose!",0

Flash:
 push hl
 push bc
 push af
 ld hl,$c008         ;address of contrast
 ld a,(hl)               ;get contrast
 ld c,a
 ld a,31
 out (2),a   ;update contrast
 ld a,(FlashLength)
 ld b,a
FlashLoop:
 halt
 djnz FlashLoop
 ld a,c
 out (2),a
 pop af
 pop bc
 pop hl
 ret
FlashLength:
 .db 7
DispHealth:
; Display Health
 ld bc,0
 ld (_curCol),bc
 ld bc,7
 ld (_curRow),bc
 ld a,(P1Health)
 ld l,a
 ld h,0
 xor a ; ld a,0
 call $4A33
 ld bc,16
 ld (_curCol),bc
 ld a,(P2Health)
 ld l,a
 ld h,0
 xor a ; ld a,0
 call $4A33
 ret

Quit:
; Write the main timer back to preserve randomness
 ld hl,$d6fc
 rst 20h
 rst 10h
 ld a,0
 ld hl,SaveStart-_asm_exec_ram+4
 add hl,de
 adc a,b
 call 5285h
 ld a,0
 ld hl,SaveStart
 call 4647h
 ld hl,SaveEnd-SaveStart
 call 464Fh
 call 52EDh

 set 2,(iy+13)
 call $4AAD ; run indic on
 call _clrScrn
 call _homeup
 ret

; bc = message position
; Messages are 30 characters long, 4 messages for each position
; 0 = enemy hits player
; 120 = enemy gets hit
; 240 = introduction
; 360 = enemy wins
; 480 = enemy loses
DispMessage:
 push bc
 call ClearMessage
 ld hl,MessageFile-1
 rst 20h
 rst 10h
 jr c,NoMessageFile
 ex de, hl
 ld a, b
 call 462Fh
 inc hl
 inc hl
 push hl
 call Random
 and 3
 ld l,a
 ld h,30
 call $4547 ; h * l
 pop de
 pop bc
 add hl,bc ; offset + position
 add hl,de ; + message location
 ld bc,0
 ld (_penCol),bc
 ld (_penRow),bc
 ld b,30
DispMessageLoop:
 ld a,(hl)
 call _vputmap
 inc hl
 djnz DispMessageLoop
 ; Set timer
 ld a,(MainTimer)
 add a,30
 ld (MessageTimer),a
 ret
NoMessageFile:
 pop bc
 ret
 
MessageFile:
 .db 8,"sparmesg"
MessageTimer:
 .db 0

ClearMessage:
 ld bc,0
 ld (_penCol),bc
 ld (_penRow),bc
 ld b,120
 ld a,32
Spaceloop:
 push bc
 ld a,32
 call _vputmap
 pop bc
 djnz Spaceloop
 ret

FP_RLD:  .db $00
FP_Bits: .db $80,$40,$20,$10,$08,$04,$02,$01

P1X:
 .db 0
P1Y:
 .db 0
P2X:
 .db 0
P2Y:
 .db 0

P1Pict:
 .dw 0
P2Pict:
 .dw 0
P1CData:
 .dw 0
P2CData:
 .dw 0
SaveStart:
MainTimer:
 .db 0
; possibly more
SaveEnd:
P1Rev:
 .db 0
P1Status:
 .db 0
P1Timer:
 .db 0
P1XTimer:
 .db 0
P1ZTimer:
 .db 0
P1Health:
 .db 0
P1Damage: ; Damage done to enemy if they are near
 .db 0
P1JumpCnt:
 .db 0
P1JumpDelta:
 .db 0
P1DelayFactor:
 .db 0
P2Status:
 .db 0
P2Timer:
 .db 0
P2XTimer:
 .db 0
P2Health:
 .db 0
P2Damage: ; Damage done to enemy if they are near
 .db 0
P2Dif0: ; used to make getting it into a 2-byte 
 .db 0
P2Dif:
 .db 0
P2DelayFactor: ; for AI purposes, how many turns until calc can punch again
 .db 0

WinState:
 .db 0

; Your behavior data
; character behavior data
ACharData:

APunchDam: ; 0 bytes from char data
 .db 7
APunchTimer: ; 1
 .db 2
APunchXTimer: ; 2
 .db 8
APunchZTimer: ; 3
 .db 6
AKickDam: ; 4
 .db 10
AKickTimer: ; 5
 .db 7
AKickXTimer: ; 6
 .db 8
AKickZTimer: ; 7
 .db 8
ABlockTimer: ; 8
 .db 2
ABlockXTimer: ; 9
 .db 7
AFKickDam: ; 10
 .db 15
AFKickZTimer: ; 11
 .db 25
ADelayFact: ; 12
 .db 15

BCharData:
BPunchDam:
 .db 6
BPunchTimer:
 .db 3
BPunchXTimer:
 .db 5
BPunchZTimer:
 .db 3
BKickDam:
 .db 7
BKickTimer:
 .db 5
BKickXTimer:
 .db 8
BKickZTimer:
 .db 7
BBlockTimer:
 .db 2
BBlockXTimer:
 .db 10
BFKickDam:
 .db 12
BFKickZTimer:
 .db 10
BDelayFact:
 .db 14

CCharData:
CPunchDam:
 .db 3
CPunchTimer:
 .db 2
CPunchXTimer:
 .db 3
CPunchZTimer:
 .db 3
CKickDam:
 .db 5
CKickTimer:
 .db 3
CKickXTimer:
 .db 5
CKickZTimer:
 .db 5
CBlockTimer:
 .db 1
CBlockXTimer:
 .db 8
CFKickDam:
 .db 10
CFKickZTimer:
 .db 8
CDelayFact:
 .db 10

; for clearing the characters 
XP1Status:
 .dw 0
XP1X:
 .db 0
XP1Y:
 .db 0
XP1Rev:
 .db 0
XP2Status:
 .dw 0
XP2X:
 .db 0
XP2Y:
 .db 0
XP2Rev:
 .db 0

P1Sprites:
P2Sprites:

CharacterA:

AReady1:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %11111000, %00000000
	.db %00000001, %00000100, %00000000
	.db %00000001, %00010100, %00000000
	.db %00000010, %00010010, %00000000
	.db %00000010, %00000010, %00000000
	.db %00000001, %00111100, %00000000
	.db %00000001, %00000100, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000010, %00000001, %00001100
	.db %00000100, %00000001, %10010010
	.db %00001010, %00000001, %01100100
	.db %00001010, %00000011, %00001000
	.db %00001010, %00000010, %11110000
	.db %00001001, %10000010, %00000000
	.db %00000100, %01000010, %00000000
	.db %00000011, %10000010, %00000000
	.db %00000011, %11111110, %00000000
	.db %00000100, %00000001, %00000000
	.db %00000100, %00000001, %00000000
	.db %00001000, %00000000, %10000000
	.db %00001000, %00100000, %10000000
	.db %00010000, %01010000, %01000000
	.db %00010000, %10001000, %01000000
	.db %00100001, %00000100, %00100000
	.db %00100010, %00000010, %00100000
	.db %01000100, %00000001, %00011000
	.db %01000010, %00000000, %10000100
	.db %00111100, %00000000, %01111000
	.db %00000000, %00000000, %00000000

AReady2:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %11111000, %00000000
	.db %00000001, %00000100, %00000000
	.db %00000001, %00010100, %00000000
	.db %00000010, %00010010, %00000000
	.db %00000010, %00000010, %00000000
	.db %00000001, %00111100, %00000000
	.db %00000001, %00000100, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000010, %00000001, %00001100
	.db %00000100, %00000001, %10010010
	.db %00001010, %00000001, %01100100
	.db %00001010, %00000011, %00001000
	.db %00001010, %00000010, %11110000
	.db %00001001, %10000010, %00000000
	.db %00000100, %01000010, %00000000
	.db %00000011, %10000010, %00000000
	.db %00000011, %11111110, %00000000
	.db %00000010, %00000001, %00000000
	.db %00000010, %00000001, %00000000
	.db %00000010, %00100001, %00000000
	.db %00000100, %01010000, %10000000
	.db %00000100, %01001000, %10000000
	.db %00000100, %10001000, %10000000
	.db %00001000, %10000100, %01000000
	.db %00001001, %00000010, %01000000
	.db %00001001, %00000010, %00110000
	.db %00010000, %10000001, %00001000
	.db %00001111, %00000000, %11110000
	.db %00000000, %00000000, %00000000

AOuchie:
	.db %00000000, %01000010, %00000000
	.db %00010000, %10100101, %00000000
	.db %00101001, %00101001, %00000000
	.db %00100111, %11111000, %10111000
	.db %00010001, %00000100, %11001000
	.db %00010001, %00011100, %00010000
	.db %00001010, %00000010, %00010000
	.db %00001010, %00011110, %00100000
	.db %00110001, %00100000, %00010000
	.db %11000001, %00011100, %00001000
	.db %01000001, %11111110, %00000100
	.db %00100010, %00000001, %00000100
	.db %00010100, %00000000, %10000010
	.db %00101010, %00000010, %10000100
	.db %11001010, %00000010, %10001000
	.db %01001010, %00000010, %10001000
	.db %00101010, %00000010, %10001000
	.db %00011010, %00000010, %10000100
	.db %00001010, %00000010, %10000010
	.db %00010111, %11111111, %00001100
	.db %01100100, %00000001, %00010000
	.db %10000100, %00000001, %00001000
	.db %01001000, %00000000, %10000100
	.db %00101000, %00100000, %11101000
	.db %00010000, %01010000, %01010000
	.db %00010000, %10001000, %01000000
	.db %00100001, %00011100, %00100000
	.db %00100011, %00010110, %00100000
	.db %01000101, %00100101, %00011000
	.db %01000010, %10100011, %10000100
	.db %00111100, %01000000, %01111000
	.db %00000000, %00000000, %00000000

ABlock1:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %11111000, %00000000
	.db %00000001, %00000100, %00000000
	.db %00000001, %00010100, %00000000
	.db %00000010, %00010010, %00000000
	.db %00000010, %00000010, %00000000
	.db %00000001, %00111100, %00000000
	.db %00000001, %00000100, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000010, %00000001, %00001100
	.db %00000100, %00000000, %10010010
	.db %00001100, %00000001, %01100100
	.db %00001010, %00000001, %00001000
	.db %00001010, %00000001, %11110000
	.db %00001001, %10000001, %00000000
	.db %00000100, %01000001, %00000000
	.db %00000011, %10000001, %00000000
	.db %00000011, %11111111, %00000000
	.db %00000010, %00000000, %10000000
	.db %00000010, %00000000, %10000000
	.db %00000100, %00010000, %01000000
	.db %00000100, %00101000, %00100000
	.db %00001000, %01000100, %00100000
	.db %00001000, %10000010, %00010000
	.db %00010001, %00000001, %00001000
	.db %00010010, %00000000, %10001000
	.db %00100100, %00000000, %10001000
	.db %00100010, %00000000, %10000100
	.db %00011100, %00000000, %01111000
	.db %00000000, %00000000, %00000000

ABlock2:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %11111000, %00000000
	.db %00000001, %00000100, %00000000
	.db %00000001, %00010100, %00000000
	.db %00000010, %00010010, %00000000
	.db %00000010, %00000010, %01000000
	.db %00000001, %00111100, %10100000
	.db %00000001, %00000100, %10100000
	.db %00000001, %11111100, %10100000
	.db %00000010, %00000010, %10100000
	.db %00000100, %00000001, %10100000
	.db %00001000, %00000000, %00100000
	.db %00001001, %00000011, %11000000
	.db %00010010, %00000010, %00000000
	.db %00001001, %00000010, %00000000
	.db %00000100, %10000010, %00000000
	.db %00000011, %00000010, %00000000
	.db %00000011, %11111110, %00000000
	.db %00000100, %00000010, %00000000
	.db %00000100, %00000001, %00000000
	.db %00001000, %00100000, %10000000
	.db %00001000, %01011000, %01000000
	.db %00010000, %10000100, %00100000
	.db %00010001, %00000011, %00100000
	.db %00100010, %00000010, %01000000
	.db %00100100, %00000100, %01000000
	.db %01001000, %00000100, %10000000
	.db %01000100, %00001000, %01000000
	.db %00111000, %00000111, %10000000
	.db %00000000, %00000000, %00000000

APunch1:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %11111000, %00000000
	.db %00000001, %00000100, %00000000
	.db %00000001, %00010100, %00000000
	.db %00000010, %00010010, %00000000
	.db %00000010, %00000010, %00000000
	.db %00000001, %00111100, %00000000
	.db %00000001, %00000100, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000010, %00000001, %00001100
	.db %00000100, %00000000, %10010010
	.db %00001100, %00000001, %01100100
	.db %00001010, %00000001, %00001000
	.db %00001010, %00000001, %11110000
	.db %00001001, %10000001, %00000000
	.db %00000100, %01000001, %00000000
	.db %00000011, %10000001, %00000000
	.db %00000011, %11111111, %00000000
	.db %00000010, %00000000, %10000000
	.db %00000010, %00000000, %10000000
	.db %00000100, %00010000, %01000000
	.db %00000100, %00101000, %00100000
	.db %00001000, %01000100, %00100000
	.db %00001000, %10000010, %00010000
	.db %00010001, %00000001, %00001000
	.db %00010010, %00000000, %10001000
	.db %00100100, %00000000, %10001000
	.db %00100010, %00000000, %10000100
	.db %00011100, %00000000, %01111000
	.db %00000000, %00000000, %00000000

APunch2:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %11111000, %00000000
	.db %00000001, %00000100, %00000000
	.db %00000001, %00010100, %00000000
	.db %00000010, %00010010, %00000000
	.db %00000010, %00000010, %00000000
	.db %00000001, %00111100, %00000000
	.db %00000001, %00000100, %00000000
	.db %00000001, %11111100, %00000000
	.db %00000010, %00000011, %11111100
	.db %00000100, %00000000, %00000010
	.db %00001000, %00000001, %11111100
	.db %00001001, %00000010, %00000000
	.db %00010010, %00000010, %00000000
	.db %00001001, %00000010, %00000000
	.db %00000100, %10000010, %00000000
	.db %00000011, %00000010, %00000000
	.db %00000011, %11111110, %00000000
	.db %00000100, %00000010, %00000000
	.db %00000100, %00000001, %00000000
	.db %00001000, %00100000, %10000000
	.db %00001000, %01011000, %01000000
	.db %00010000, %10000100, %00100000
	.db %00010001, %00000011, %00100000
	.db %00100010, %00000010, %01000000
	.db %00100100, %00000100, %01000000
	.db %01001000, %00000100, %10000000
	.db %01000100, %00001000, %01000000
	.db %00111000, %00000111, %10000000
	.db %00000000, %00000000, %00000000

AKick1:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %11111000, %00000000
	.db %00000001, %00000100, %00000000
	.db %00000001, %00010100, %00000000
	.db %00000010, %00010010, %00000000
	.db %00000010, %00000010, %00000000
	.db %00000001, %00111100, %00000000
	.db %00000001, %00000100, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000010, %00000001, %00000000
	.db %00000100, %00000001, %10010000
	.db %00001010, %00000001, %01101000
	.db %00001010, %00000001, %00001000
	.db %00010100, %00000010, %11010000
	.db %00010011, %00000010, %00100000
	.db %00001100, %10000010, %00000000
	.db %00000011, %00000010, %00000000
	.db %00000011, %11111110, %00000000
	.db %00000100, %00000010, %00000000
	.db %00000100, %00000010, %00000000
	.db %00000100, %00000001, %00000000
	.db %00000100, %00100001, %00000000
	.db %00000100, %01010000, %10000000
	.db %00001000, %01001000, %10000000
	.db %00001000, %10000100, %10000000
	.db %00001000, %10000100, %10000000
	.db %00001000, %10001000, %10000000
	.db %00001000, %01001000, %01000000
	.db %00000111, %10000111, %10000000
	.db %00000000, %00000000, %00000000

AKick2:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %11111000, %00000000
	.db %00000001, %00000100, %00000000
	.db %00000001, %00010100, %00000000
	.db %00000010, %00010010, %00000000
	.db %00000010, %00000010, %00000000
	.db %00000001, %00111100, %00000000
	.db %00000001, %00000100, %00000000
	.db %00000011, %11111100, %00000000
	.db %00000100, %00000010, %00000000
	.db %00001000, %00000001, %01100000
	.db %00010100, %00000000, %10100000
	.db %00010100, %00000010, %00100000
	.db %00101000, %00000101, %11000000
	.db %00100100, %00000100, %00000000
	.db %00010010, %00000100, %00000000
	.db %00001010, %00000100, %00001000
	.db %00000111, %11111111, %00010100
	.db %00000100, %00000000, %11110100
	.db %00001000, %00000000, %00000100
	.db %00001000, %00000000, %00000100
	.db %00001000, %01111111, %11111000
	.db %00001000, %10000000, %00000000
	.db %00010001, %00000000, %00000000
	.db %00010001, %00000000, %00000000
	.db %00010010, %00000000, %00000000
	.db %00100010, %00000000, %00000000
	.db %00100001, %00000000, %00000000
	.db %00011110, %00000000, %00000000
	.db %00000000, %00000000, %00000000

AWin:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000001, %10111110, %01100000
	.db %00000010, %11000001, %10010000
	.db %00000101, %01010101, %01001000
	.db %00001010, %10010100, %10101000
	.db %00001010, %10000000, %10101000
	.db %00001010, %01011101, %00101000
	.db %00001010, %01000001, %00101000
	.db %00001001, %01111111, %01001000
	.db %00000100, %10000000, %10010000
	.db %00000010, %00000000, %00100000
	.db %00000001, %00000000, %01000000
	.db %00000000, %10000000, %10000000
	.db %00000000, %10000000, %10000000
	.db %00000000, %10000000, %10000000
	.db %00000000, %01000001, %00000000
	.db %00000000, %01000001, %00000000
	.db %00000000, %01111111, %00000000
	.db %00000000, %01000001, %00000000
	.db %00000000, %10000000, %10000000
	.db %00000000, %10000000, %10000000
	.db %00000000, %10001000, %10000000
	.db %00000000, %10010100, %10000000
	.db %00000000, %10010100, %10000000
	.db %00000000, %10010100, %10000000
	.db %00000000, %10010100, %10000000
	.db %00000001, %00010100, %01000000
	.db %00000010, %00010100, %00100000
	.db %00000001, %11100011, %11000000
	.db %00000000, %00000000, %00000000

AFKick:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %11111000, %00000000
	.db %00000001, %00000100, %00000000
	.db %00000001, %00010100, %00000000
	.db %00000010, %00010010, %00000000
	.db %00000010, %00000010, %00000000
	.db %00000001, %00111100, %00000000
	.db %00000001, %00000100, %00000000
	.db %00000011, %11111100, %00000000
	.db %00000100, %00000010, %00000000
	.db %00001000, %00000001, %01100000
	.db %00010100, %00000000, %10100000
	.db %00010100, %00000010, %00100000
	.db %00101000, %00000101, %11000000
	.db %00100100, %00000100, %00000000
	.db %00010010, %00000100, %00000000
	.db %00001010, %00000100, %00000000
	.db %00000011, %11111100, %00000000
	.db %00000100, %00000011, %10001000
	.db %00001000, %00000000, %01110100
	.db %00010000, %01100000, %00000100
	.db %00010000, %10011111, %00000100
	.db %00010000, %01000000, %11111000
	.db %00001000, %00111000, %00000000
	.db %00000111, %00001000, %00000000
	.db %00000000, %11001000, %00000000
	.db %00000000, %00110000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000

CharacterB:

BReady1:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %01111000, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000011, %11000111, %00000000
	.db %00000011, %10001011, %00000000
	.db %00000001, %00001010, %00000000
	.db %00000001, %00100010, %00000000
	.db %00000001, %00011110, %00000000
	.db %00000000, %10000100, %00000000
	.db %00000000, %11111000, %00100000
	.db %00000001, %01000110, %01010000
	.db %00000010, %00101001, %10010000
	.db %00000100, %00010000, %00100000
	.db %00001000, %10001000, %11000000
	.db %00001001, %00000101, %00000000
	.db %00000100, %11000010, %00000000
	.db %00000010, %00100010, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000001, %00111001, %00000000
	.db %00000001, %01101101, %00000000
	.db %00000010, %01010000, %10000000
	.db %00000010, %00101000, %10000000
	.db %00000100, %01001000, %01000000
	.db %00000100, %01000100, %01000000
	.db %00001000, %10000010, %00100000
	.db %00001001, %00000001, %00100000
	.db %00010001, %00000001, %00010000
	.db %00010000, %10000000, %10001000
	.db %00001111, %00000000, %01110000
	.db %00000000, %00000000, %00000000

BReady2:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %01111000, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000011, %11000111, %00000000
	.db %00000011, %10001011, %00000000
	.db %00000001, %00001010, %00000000
	.db %00000001, %00100010, %00000000
	.db %00000001, %00011110, %00000000
	.db %00000000, %10000100, %00000000
	.db %00000000, %11111000, %00100000
	.db %00000001, %01000110, %01010000
	.db %00000010, %00101001, %10010000
	.db %00000100, %00010000, %00100000
	.db %00001000, %10001000, %11000000
	.db %00001001, %00000101, %00000000
	.db %00000100, %11000010, %00000000
	.db %00000010, %00100010, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000001, %00111001, %00000000
	.db %00000001, %00101101, %00000000
	.db %00000001, %00010000, %10000000
	.db %00000010, %00101000, %10000000
	.db %00000010, %00101000, %10000000
	.db %00000010, %00100100, %01000000
	.db %00000100, %01000100, %01000000
	.db %00000100, %01000010, %00100000
	.db %00000100, %01000010, %00100000
	.db %00000100, %00100001, %00010000
	.db %00000011, %11000000, %11100000
	.db %00000000, %00000000, %00000000

BOuchie:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %01110000
	.db %00000000, %01111000, %10010000
	.db %00001101, %11111111, %00010000
	.db %01110011, %11000111, %00100000
	.db %01000011, %10001111, %00100000
	.db %00110001, %00000010, %00100000
	.db %00001001, %00001110, %01000000
	.db %00000101, %00010000, %00100000
	.db %00000100, %10001100, %00011000
	.db %00001000, %11111100, %00000110
	.db %01110001, %01000110, %00011110
	.db %10000010, %00101001, %00100000
	.db %01000010, %00010001, %00011000
	.db %00100010, %10001101, %00000100
	.db %00010010, %10000101, %00000010
	.db %00001010, %10000101, %00000100
	.db %00001010, %10000101, %00011000
	.db %00010001, %11111110, %00100000
	.db %00100001, %11111110, %00010000
	.db %01000001, %00111001, %00001100
	.db %10011001, %01101101, %00000010
	.db %01100110, %01010000, %10001100
	.db %00000010, %00101000, %10110000
	.db %00001100, %01001000, %01000000
	.db %00010100, %01000100, %01000000
	.db %00101000, %11000110, %00100000
	.db %00111001, %00101001, %00100000
	.db %00010001, %00010001, %00010000
	.db %00100010, %00000000, %10001000
	.db %00011110, %00000000, %01110000
	.db %00000000, %00000000, %00000000

BBlock1:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %01111000, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000011, %11000111, %00000000
	.db %00000011, %10001011, %00000000
	.db %00000001, %00001010, %00000000
	.db %00000001, %00100010, %00000000
	.db %00000001, %00011110, %00000000
	.db %00000000, %10000100, %00000000
	.db %00000000, %11111000, %00000000
	.db %00000001, %01000110, %00000000
	.db %00000010, %00101001, %00000000
	.db %00000100, %00010000, %10110000
	.db %00001001, %00001000, %01001000
	.db %00001010, %00000101, %00010000
	.db %00001001, %10000010, %11100000
	.db %00000110, %01000010, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000001, %00111001, %00000000
	.db %00000001, %01101101, %00000000
	.db %00000010, %01010000, %10000000
	.db %00000010, %00101000, %10000000
	.db %00000100, %01001000, %01000000
	.db %00000100, %01000100, %01000000
	.db %00001000, %10000010, %00100000
	.db %00001001, %00000001, %00100000
	.db %00010001, %00000001, %00010000
	.db %00010000, %10000000, %10001000
	.db %00001111, %00000000, %01110000
	.db %00000000, %00000000, %00000000

BBlock2:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %01111000, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000011, %11000111, %00000000
	.db %00000011, %10001011, %00000000
	.db %00000001, %00001010, %00100000
	.db %00000001, %00100010, %01010000
	.db %00000001, %00011110, %01010000
	.db %00000000, %10000100, %01010000
	.db %00000000, %11111000, %01010000
	.db %00000001, %01000110, %01010000
	.db %00000010, %00101001, %11010000
	.db %00000100, %00010000, %00010000
	.db %00001000, %10001001, %11100000
	.db %00001001, %00000110, %00000000
	.db %00000100, %11000010, %00000000
	.db %00000010, %00100010, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000001, %00111001, %00000000
	.db %00000001, %01101101, %00000000
	.db %00000010, %01010000, %10000000
	.db %00000010, %00101000, %10000000
	.db %00000100, %01001000, %01000000
	.db %00000100, %01000100, %01000000
	.db %00001000, %10000010, %00100000
	.db %00001001, %00000001, %00100000
	.db %00010001, %00000001, %00010000
	.db %00010000, %10000000, %10001000
	.db %00001111, %00000000, %01110000
	.db %00000000, %00000000, %00000000

BPunch1:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %01111000, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000011, %11000111, %00000000
	.db %00000011, %10001011, %00000000
	.db %00000001, %00001010, %00000000
	.db %00000001, %00100010, %00000000
	.db %00000001, %00011110, %00000000
	.db %00000000, %10000100, %00000000
	.db %00000000, %11111000, %00000000
	.db %00000001, %01000110, %00000000
	.db %00000010, %00101001, %00000000
	.db %00000100, %00010000, %10110000
	.db %00001001, %00001000, %01001000
	.db %00001010, %00000101, %00010000
	.db %00001001, %10000010, %11100000
	.db %00000110, %01000010, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000001, %00111001, %00000000
	.db %00000001, %01101100, %10000000
	.db %00000010, %01010000, %10000000
	.db %00000010, %00101000, %01000000
	.db %00000100, %01000100, %01000000
	.db %00000100, %01000010, %00100000
	.db %00001000, %10000001, %00100000
	.db %00001001, %00000001, %00010000
	.db %00010001, %00000000, %10010000
	.db %00010000, %10000000, %10001000
	.db %00001111, %00000000, %01110000
	.db %00000000, %00000000, %00000000

BPunch2:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %01111000, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000011, %11000111, %00000000
	.db %00000011, %10001011, %00000000
	.db %00000001, %00001010, %00000000
	.db %00000001, %00100010, %00000000
	.db %00000001, %00011110, %00000000
	.db %00000000, %10000100, %00000000
	.db %00000000, %11111000, %00000000
	.db %00000001, %01000110, %00000000
	.db %00000010, %00101001, %11111000
	.db %00000100, %00010000, %00000100
	.db %00001001, %00001001, %11111000
	.db %00001010, %00000110, %00000000
	.db %00001001, %10000010, %00000000
	.db %00000110, %01000010, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000001, %00111001, %00000000
	.db %00000001, %01101100, %10000000
	.db %00000010, %01010000, %01000000
	.db %00000010, %00101100, %00100000
	.db %00000100, %01000010, %00010000
	.db %00000100, %01000001, %00010000
	.db %00001000, %10000001, %00010000
	.db %00001001, %00000001, %00100000
	.db %00010001, %00000010, %01000000
	.db %00010000, %10000100, %00100000
	.db %00001111, %00000011, %11000000
	.db %00000000, %00000000, %00000000

BKick1:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %01111000, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000011, %11000111, %00000000
	.db %00000011, %10001011, %00000000
	.db %00000001, %00001010, %00000000
	.db %00000001, %00100010, %00000000
	.db %00000001, %00011110, %00000000
	.db %00000000, %10000100, %00000000
	.db %00000000, %11111000, %00000000
	.db %00000001, %01000110, %00100000
	.db %00000010, %00101001, %01010000
	.db %00000100, %00010000, %10010000
	.db %00000101, %00001000, %00100000
	.db %00000101, %00000101, %11000000
	.db %00000100, %10000010, %00000000
	.db %00000010, %01000010, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000001, %00111001, %00000000
	.db %00000001, %01101101, %00000000
	.db %00000001, %01010000, %10000000
	.db %00000010, %00101000, %10000000
	.db %00000010, %00100100, %01000000
	.db %00000010, %01000010, %01000000
	.db %00000100, %01000010, %01000000
	.db %00000100, %10000100, %10000000
	.db %00000100, %11000100, %11000000
	.db %00000100, %00100100, %00100000
	.db %00000011, %11000011, %11000000
	.db %00000000, %00000000, %00000000

BKick2:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %11110000, %00000000
	.db %00000011, %11111100, %00000000
	.db %00000111, %10001110, %00000000
	.db %00000111, %00010110, %00000000
	.db %00000010, %00010100, %00000000
	.db %00000010, %01000100, %00000000
	.db %00000010, %00111100, %00000000
	.db %00000001, %00001000, %00000000
	.db %00000001, %11110000, %00000000
	.db %00000010, %10001100, %10000000
	.db %00000100, %01010011, %01000000
	.db %00001000, %00100000, %01000000
	.db %00001010, %00010011, %10000000
	.db %00001010, %00001100, %00000000
	.db %00001010, %00000100, %00000000
	.db %00001010, %00000100, %00000000
	.db %00000111, %11111100, %00001000
	.db %00000011, %11111111, %10010100
	.db %00000010, %01110000, %01110100
	.db %00000100, %11011000, %00000100
	.db %00000100, %10000000, %00000100
	.db %00000100, %00111111, %11111000
	.db %00000100, %01000000, %00000000
	.db %00001000, %10000000, %00000000
	.db %00001000, %10000000, %00000000
	.db %00001001, %00000000, %00000000
	.db %00001001, %00000000, %00000000
	.db %00001000, %10000000, %00000000
	.db %00000111, %00000000, %00000000
	.db %00000000, %00000000, %00000000

BWin:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %01111000, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000011, %10000111, %00000000
	.db %00000011, %01001011, %00000000
	.db %00000001, %01001010, %00000000
	.db %00000001, %00000010, %00000000
	.db %00001001, %01001010, %01000000
	.db %00010100, %10110100, %10100000
	.db %00101000, %11111100, %01010000
	.db %00101001, %01000110, %01010000
	.db %00100110, %00101001, %10010000
	.db %00010000, %00010000, %00100000
	.db %00001000, %00001000, %01000000
	.db %00000110, %00000101, %10000000
	.db %00000010, %00000011, %00000000
	.db %00000010, %00000001, %00000000
	.db %00000001, %11111111, %00000000
	.db %00000001, %11111111, %00000000
	.db %00000001, %00111001, %00000000
	.db %00000001, %01101101, %00000000
	.db %00000010, %01010000, %10000000
	.db %00000010, %00101000, %10000000
	.db %00000100, %01001000, %01000000
	.db %00000100, %01000100, %01000000
	.db %00001000, %10000010, %00100000
	.db %00001001, %00000001, %00100000
	.db %00010001, %00000001, %00010000
	.db %00100010, %00000000, %10001000
	.db %00011100, %00000000, %01110000
	.db %00000000, %00000000, %00000000

BFKick:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %11110000, %00000000
	.db %00000011, %11111100, %00000000
	.db %00000111, %10001110, %00000000
	.db %00000111, %00010110, %00000000
	.db %00000010, %00010100, %00000000
	.db %00000010, %01000100, %00000000
	.db %00000010, %00111100, %00000000
	.db %00000001, %00001000, %00000000
	.db %00000001, %11110000, %00000000
	.db %00000010, %10001100, %10000000
	.db %00000100, %01010011, %01000000
	.db %00001000, %00100000, %01000000
	.db %00010010, %00010011, %10000000
	.db %00010100, %00001100, %00000000
	.db %00010011, %00000100, %00000100
	.db %00001000, %10000100, %00001010
	.db %00000111, %11111101, %11110010
	.db %00000011, %11111110, %00000010
	.db %00000010, %01110000, %00001110
	.db %00000100, %11001000, %01110000
	.db %00000101, %10000001, %10000000
	.db %00000100, %00111110, %00000000
	.db %00001000, %00100000, %00000000
	.db %00001000, %00010000, %00000000
	.db %00000100, %00001000, %00000000
	.db %00000011, %10001000, %00000000
	.db %00000000, %01010000, %00000000
	.db %00000000, %01100000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000

CharacterC:

CReady1:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %00111100, %00000000
	.db %00000110, %11000010, %00000000
	.db %00001001, %10001001, %00000000
	.db %00001000, %00110111, %00000000
	.db %00010000, %01001010, %00000000
	.db %00010010, %01001010, %00000000
	.db %00010110, %10000010, %00000000
	.db %00010101, %00011100, %00000000
	.db %00010101, %00000100, %00000000
	.db %00001000, %11111000, %00000000
	.db %00000011, %10000100, %00010000
	.db %00000100, %01001010, %00101000
	.db %00001000, %00110001, %01001000
	.db %00010001, %00010000, %10010000
	.db %00010010, %00001010, %00100000
	.db %00001001, %00000111, %11000000
	.db %00000100, %10000010, %00000000
	.db %00000011, %11111110, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000001, %00000001, %00000000
	.db %00000010, %00000000, %10000000
	.db %00000010, %00010000, %10000000
	.db %00000100, %00101000, %01000000
	.db %00000100, %00100100, %01000000
	.db %00001000, %01000010, %00100000
	.db %00001000, %10000010, %00100000
	.db %00010001, %00000001, %00110000
	.db %00010000, %10000001, %00001000
	.db %00001111, %00000000, %11110000
	.db %00000000, %00000000, %00000000

CReady2:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %00111100, %00000000
	.db %00000110, %11000010, %00000000
	.db %00001001, %10001001, %00000000
	.db %00001000, %00110111, %00000000
	.db %00010000, %01001010, %00000000
	.db %00010010, %01001010, %00000000
	.db %00010110, %10000010, %00000000
	.db %00010101, %00011100, %00000000
	.db %00010101, %00000100, %00000000
	.db %00001000, %11111000, %00000000
	.db %00000011, %10000100, %00010000
	.db %00000100, %01001010, %00101000
	.db %00001000, %00110001, %01011000
	.db %00010001, %00010000, %10010000
	.db %00010010, %00001010, %00100000
	.db %00001001, %00000111, %11000000
	.db %00000100, %10000010, %00000000
	.db %00000011, %11111110, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000001, %00000010, %00000000
	.db %00000001, %00000001, %00000000
	.db %00000010, %00010001, %00000000
	.db %00000010, %00110001, %00000000
	.db %00000010, %00101000, %10000000
	.db %00000100, %01000100, %10000000
	.db %00000100, %10000100, %10000000
	.db %00000100, %10000010, %01000000
	.db %00000100, %01000010, %00100000
	.db %00000011, %10000001, %11000000
	.db %00000000, %00000000, %00000000

COuchie:
	.db %00000001, %00010000, %00000000
	.db %00010001, %10110000, %00110000
	.db %00101010, %01111100, %01001000
	.db %01000110, %11000011, %10010000
	.db %00101001, %10001001, %00010000
	.db %00011000, %00110111, %00100000
	.db %00010000, %01001110, %00100000
	.db %00110010, %01000010, %00011000
	.db %01010110, %10011100, %00000110
	.db %10010101, %00100000, %00000100
	.db %01110101, %00011100, %00001000
	.db %00111000, %11111000, %00001000
	.db %00010001, %10000110, %00010000
	.db %00001010, %01001001, %00100000
	.db %00010010, %00110001, %00010000
	.db %01100010, %10010101, %00001100
	.db %10000010, %10001101, %00000010
	.db %01000010, %10000101, %00000100
	.db %00100011, %10000111, %00000100
	.db %00010010, %11111101, %00001000
	.db %00001001, %11111110, %00110000
	.db %00010001, %00000001, %01000000
	.db %00100001, %00000001, %00100000
	.db %00100010, %00010000, %10010000
	.db %01000010, %00101000, %10010000
	.db %01000100, %01000100, %01001000
	.db %10011100, %01000100, %01111000
	.db %01101000, %10000110, %00100000
	.db %00001001, %01001001, %00100000
	.db %00010001, %00101001, %00010000
	.db %00001110, %00010000, %11100000
	.db %00000000, %00000000, %00000000

CBlock1:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %00111100, %00000000
	.db %00000110, %11000010, %00000000
	.db %00001001, %10001001, %00000000
	.db %00001000, %00110111, %00000000
	.db %00010000, %01001010, %00000000
	.db %00010010, %01001010, %00000000
	.db %00010110, %10000010, %00000000
	.db %00010101, %00011100, %00000000
	.db %00010101, %00000100, %00000000
	.db %00001000, %11111000, %00000000
	.db %00000011, %10000100, %00010000
	.db %00000100, %01001010, %00101000
	.db %00001000, %00110001, %01011000
	.db %00010011, %00010000, %10010000
	.db %00010100, %00001010, %00100000
	.db %00010011, %00000111, %11000000
	.db %00001000, %10000010, %00000000
	.db %00000111, %11111110, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000001, %00000001, %00000000
	.db %00000010, %00000000, %10000000
	.db %00000010, %00010000, %10000000
	.db %00000100, %00101000, %01000000
	.db %00000100, %00100100, %01000000
	.db %00001000, %01000010, %00100000
	.db %00001000, %10000010, %00100000
	.db %00010001, %00000001, %00110000
	.db %00010000, %10000001, %00001000
	.db %00001111, %00000000, %11110000
	.db %00000000, %00000000, %00000000

CBlock2:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %00111100, %00000000
	.db %00000110, %11000010, %00000000
	.db %00001001, %10001001, %00000000
	.db %00001000, %00110111, %00000000
	.db %00010000, %01001010, %00000000
	.db %00010010, %01001010, %00000000
	.db %00010110, %10000010, %01000000
	.db %00010101, %00011100, %10100000
	.db %00010101, %00000100, %11100000
	.db %00001000, %11111000, %10100000
	.db %00000011, %10000100, %10100000
	.db %00000100, %01001011, %00100000
	.db %00001000, %00110000, %01000000
	.db %00010001, %00010001, %10000000
	.db %00010010, %00001010, %00000000
	.db %00001001, %00000110, %00000000
	.db %00000100, %10000010, %00000000
	.db %00000011, %11111110, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000001, %00000001, %00000000
	.db %00000010, %00000000, %10000000
	.db %00000010, %00010000, %10000000
	.db %00000100, %00101000, %01000000
	.db %00000100, %00100100, %01000000
	.db %00001000, %01000010, %00100000
	.db %00001000, %10000010, %00100000
	.db %00010001, %00000001, %00110000
	.db %00010000, %10000001, %00001000
	.db %00001111, %00000000, %11110000
	.db %00000000, %00000000, %00000000

CPunch1:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %00111100, %00000000
	.db %00000110, %11000010, %00000000
	.db %00001001, %10001001, %00000000
	.db %00001000, %00110111, %00000000
	.db %00010000, %01001010, %00000000
	.db %00010010, %01001010, %00000000
	.db %00010110, %10000010, %00000000
	.db %00010101, %00011100, %00000000
	.db %00010101, %00000100, %00000000
	.db %00001000, %11111000, %00000000
	.db %00000011, %10000100, %00100000
	.db %00000100, %01001010, %01010000
	.db %00001000, %00110001, %10010000
	.db %00010011, %00010000, %00100000
	.db %00010100, %00001011, %11000000
	.db %00010011, %00000110, %00000000
	.db %00001000, %10000010, %00000000
	.db %00000111, %11111110, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000001, %00000001, %00000000
	.db %00000010, %00000000, %10000000
	.db %00000010, %00010000, %10000000
	.db %00000100, %00101000, %01000000
	.db %00000100, %00100100, %01000000
	.db %00001000, %01000010, %00100000
	.db %00001000, %10000010, %00100000
	.db %00010001, %00000001, %00110000
	.db %00010000, %10000001, %00001000
	.db %00001111, %00000000, %11110000
	.db %00000000, %00000000, %00000000

CPunch2:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %00011110, %00000000
	.db %00000011, %01100001, %00000000
	.db %00000100, %11000100, %10000000
	.db %00000100, %00011011, %10000000
	.db %00001000, %00100101, %00000000
	.db %00001001, %00100101, %00000000
	.db %00001011, %01000001, %00000000
	.db %00001010, %10001110, %00000000
	.db %00001010, %10000010, %00000000
	.db %00000100, %01111100, %00000000
	.db %00000001, %11000010, %00000000
	.db %00000010, %00100101, %11111000
	.db %00000100, %00011000, %00010100
	.db %00001000, %10001000, %11111000
	.db %00001001, %00000101, %00000000
	.db %00000100, %10000011, %00000000
	.db %00000010, %01000001, %00000000
	.db %00000001, %11111111, %00000000
	.db %00000001, %11111111, %00000000
	.db %00000001, %00000000, %10000000
	.db %00000010, %00000000, %01000000
	.db %00000010, %00001000, %00100000
	.db %00000100, %00010100, %00010000
	.db %00000100, %00100010, %00010000
	.db %00001000, %01000001, %00100000
	.db %00001000, %10000010, %00100000
	.db %00010001, %00000010, %01000000
	.db %00010000, %10000100, %00100000
	.db %00001111, %00000011, %11000000
	.db %00000000, %00000000, %00000000

CKick1:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %00111100, %00000000
	.db %00000110, %11000010, %00000000
	.db %00001001, %10001001, %00000000
	.db %00001000, %00110111, %00000000
	.db %00010000, %01001010, %00000000
	.db %00010010, %01001010, %00000000
	.db %00010110, %10000010, %00000000
	.db %00010101, %00011100, %00000000
	.db %00010101, %00000100, %00000000
	.db %00001000, %11111000, %00000000
	.db %00000011, %10000100, %00010000
	.db %00000100, %01001010, %00101000
	.db %00001000, %00110001, %11001000
	.db %00010001, %00010000, %10010000
	.db %00010010, %00001010, %00100000
	.db %00001001, %00000111, %11000000
	.db %00000100, %10000010, %00000000
	.db %00000011, %11111110, %00000000
	.db %00000001, %11111110, %00000000
	.db %00000001, %00000010, %00000000
	.db %00000001, %00000001, %00000000
	.db %00000001, %00010001, %00000000
	.db %00000010, %00101000, %10000000
	.db %00000010, %00100100, %01000000
	.db %00000010, %01000010, %01000000
	.db %00000010, %01000100, %10000000
	.db %00000010, %01000100, %10000000
	.db %00000010, %00100010, %01000000
	.db %00000001, %11000001, %10000000
	.db %00000000, %00000000, %00000000

CKick2:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %01111000, %00000000
	.db %00001101, %10000100, %00000000
	.db %00010011, %00010010, %00000000
	.db %00010000, %01101110, %00000000
	.db %00100000, %10010100, %00000000
	.db %00100100, %10010100, %00000000
	.db %00101101, %00000100, %00000000
	.db %00101110, %00111000, %00000000
	.db %00101010, %00001000, %00000000
	.db %00010001, %11110000, %00000000
	.db %00000111, %00001000, %01100000
	.db %00001000, %10010100, %10100000
	.db %00010000, %01100011, %00100000
	.db %00100100, %00100000, %01000000
	.db %00101000, %00010111, %10001000
	.db %00100100, %00001100, %00010100
	.db %00010100, %00000100, %01100100
	.db %00001111, %11111111, %10000100
	.db %00000011, %11111100, %00001000
	.db %00000010, %00000000, %00110000
	.db %00000100, %00000000, %11000000
	.db %00000100, %00111111, %00000000
	.db %00000100, %01000000, %00000000
	.db %00001000, %10000000, %00000000
	.db %00001001, %00000000, %00000000
	.db %00001001, %00000000, %00000000
	.db %00010010, %00000000, %00000000
	.db %00010001, %00000000, %00000000
	.db %00001110, %00000000, %00000000
	.db %00000000, %00000000, %00000000

CWin:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %01111100, %00000000
	.db %00000011, %10000010, %00000000
	.db %00000110, %00011001, %00000000
	.db %00000100, %11100111, %00000000
	.db %00000101, %01001010, %10000000
	.db %00000110, %01001010, %00000000
	.db %00001010, %00000010, %00110000
	.db %00001010, %01001010, %01010000
	.db %00010011, %00110100, %10010000
	.db %00010110, %11111001, %00100000
	.db %00001001, %10000110, %01000000
	.db %00000010, %01001000, %10000000
	.db %00000100, %00110001, %00000000
	.db %00000100, %00010001, %00000000
	.db %00000101, %00001001, %00000000
	.db %00001010, %00000101, %00000000
	.db %00001010, %00000011, %00000000
	.db %00001011, %11111111, %00000000
	.db %00000101, %11111111, %00000000
	.db %00000001, %00000001, %00000000
	.db %00000010, %00000001, %00000000
	.db %00000010, %00010000, %10000000
	.db %00000010, %00101000, %10000000
	.db %00000010, %00101000, %10000000
	.db %00000001, %00101001, %00000000
	.db %00000001, %00101001, %00000000
	.db %00000001, %00101001, %00000000
	.db %00000010, %00101000, %10000000
	.db %00000001, %11000111, %00000000
	.db %00000000, %00000000, %00000000

CFKick:
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %01111000, %00000000
	.db %00001101, %10000100, %00000000
	.db %00010011, %00010010, %00000000
	.db %00010000, %01101110, %00000000
	.db %00100000, %10010100, %00000000
	.db %00100100, %10010100, %00000000
	.db %00101101, %00000100, %00000000
	.db %00101010, %00111000, %00000000
	.db %00101010, %00001000, %00000000
	.db %00010001, %11110000, %00000000
	.db %00000111, %00001000, %01100000
	.db %00001000, %10010100, %10100000
	.db %00010000, %01100011, %00100000
	.db %00100100, %00100000, %01000100
	.db %00101000, %00010111, %10001010
	.db %00100100, %00001100, %00110010
	.db %00010100, %00000100, %11000010
	.db %00001111, %11111111, %00000100
	.db %00000011, %11111100, %00001000
	.db %00000010, %00000000, %01110000
	.db %00000100, %00000011, %10000000
	.db %00000100, %00111100, %00000000
	.db %00000100, %01000000, %00000000
	.db %00001000, %00100000, %00000000
	.db %00001000, %00011100, %00000000
	.db %00000100, %00000100, %00000000
	.db %00000011, %11001000, %00000000
	.db %00000000, %00110000, %00000000
	.db %00000000, %00000000, %00000000
	.db %00000000, %00000000, %00000000

.end
